# ExtendSelector

Extends \BaseSelector

Selector that selects files by forwarding the request on to other classes.

TODO - Consider adding Path (phing.types.Path) support to this class

        and to the Mappers class.  See Ant versions for implimentation details.

author | Hans Lellelid hans@xmpl.org (Phing)
author | Bruce Atherton bruce@callenish.com (Ant)
package | phing.types.selectors

### Methods

## Create new parameters to pass to custom selector.

    addParam(\Parameter $p)

### Arguments

#### $p

`\Parameter`

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

inherited

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p)

inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName)

inherited

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

## Return the description for the current data type.

    getDescription()

inherited

## Returns any error messages that have been set.

    getError() : \the

inherited

### Response

`\the`

error condition

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference()

inherited

## Allows the custom selector to choose whether to select a file. This is also where the Parameters are passed to the custom selector.

    isSelected(\PhingFile $basedir,  $filename, \PhingFile $file)

throws |

### Arguments

#### $basedir

`\PhingFile`

#### $filename

``

#### $file

`\PhingFile`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO)

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

inherited

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

inherited

## Instantiates the identified custom selector class.

    selectorCreate()

## Sets the classname of the custom selector.

    setClassname( $classname)

### Arguments

#### $classname

``

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription( $desc)

inherited

### Arguments

#### $desc

``

## Allows all selectors to indicate a setup error. Note that only the first error message is recorded.

    setError( $msg)

inherited

### Arguments

#### $msg

``

## References the project to the current component.

    setProject(\Project $project)

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

inherited

## Subclasses can use this to throw the requisite exception in isSelected() in the case of an error condition.

    validate()

inherited

## <p>Subclasses can override this method to provide checking of their state. So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).</p> <p>Implementations should check for incorrect settings and call setError() as necessary.</p>

    verifySettings()

inherited

### Properties

## classname

    classname :

### Type(s)

``

## dynselector

    dynselector :

### Type(s)

``

## parameters

    parameters :

### Type(s)

``

## errmsg

    errmsg :

inherited

### Type(s)

``

## The descriptin the user has set.

    description :

inherited

### Type(s)

``

## Value to the refid attribute. Type of Reference

    ref :

inherited

### Type(s)

``

## Are we sure we don't hold circular references?

    checked : boolean

inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`